<?xml version="1.0" encoding="iso-8859-1"?>
<!DOCTYPE html PUBLIC "-//W3C//DTD XHTML 1.0 Transitional//EN"
    "http://www.w3.org/TR/xhtml1/DTD/xhtml1-transitional.dtd">
<html xmlns="http://www.w3.org/1999/xhtml" lang="en">
<!-- Source/Synopsis/Formatters/HTML/XRefPager.py.html -->
<!-- this view was generated by Source -->
<head>
<meta content="text/html; charset=iso-8859-1" http-equiv="Content-Type"/>
<title >Synopsis - Synopsis/Formatters/HTML/XRefPager.py</title>
<link href="../../../../style.css" type="text/css" rel="stylesheet" />
</head>
<body class="Source">
<div class="navigation">
<span class="normal"><a href="../../../../Scopes/Synopsis.html" >Global Package</a></span>
<span class="normal"><a href="../../../../InheritanceTree.html" >Inheritance Tree</a></span>
<span class="normal"><a href="../../../../InheritanceGraph.html" >Inheritance Graph</a></span>
<span class="normal"><a href="../../../../NameIndex.html" >Name Index</a></span>
</div>
File: <b >Synopsis/Formatters/HTML/XRefPager.py</b><pre class="sxr"><a id="line1"></a><span class="lineno"> 1</span><span class="line"><span class="py-comment">#</span></span>
<a id="line2"></a><span class="lineno"> 2</span><span class="line"><span class="py-comment"># Copyright (C) 2008 Stefan Seefeld</span></span>
<a id="line3"></a><span class="lineno"> 3</span><span class="line"><span class="py-comment"># All rights reserved.</span></span>
<a id="line4"></a><span class="lineno"> 4</span><span class="line"><span class="py-comment"># Licensed to the public under the terms of the GNU LGPL (&gt;= 2),</span></span>
<a id="line5"></a><span class="lineno"> 5</span><span class="line"><span class="py-comment"># see the file COPYING for details.</span></span>
<a id="line6"></a><span class="lineno"> 6</span><span class="line"><span class="py-comment">#</span></span>
<a id="line7"></a><span class="lineno"> 7</span>
<a id="line8"></a><span class="lineno"> 8</span><span class="line"><span class="py-keyword">class</span> <a href="../../../../Scopes/Synopsis/Formatters/HTML/XRefPager/XRefPager.html">XRefPager</a>:</span>
<a id="line9"></a><span class="lineno"> 9</span><span class="line">    <span class="py-string">&quot;&quot;&quot;Generates pages of cross-references.&quot;&quot;&quot;</span></span>
<a id="line10"></a><span class="lineno">10</span>
<a id="line11"></a><span class="lineno">11</span><span class="line">    <span class="py-keyword">def</span> <a href="../../../../Scopes/Synopsis/Formatters/HTML/XRefPager/XRefPager.html#__init__">__init__</a>(self, ir):</span>
<a id="line12"></a><span class="lineno">12</span>
<a id="line13"></a><span class="lineno">13</span><span class="line">        self.page_map = {}</span>
<a id="line14"></a><span class="lineno">14</span><span class="line">        self.page_info = []</span>
<a id="line15"></a><span class="lineno">15</span>
<a id="line16"></a><span class="lineno">16</span><span class="line">        <span class="py-comment"># Split the data into multiple files based on size</span></span>
<a id="line17"></a><span class="lineno">17</span><span class="line">        page = 0</span>
<a id="line18"></a><span class="lineno">18</span><span class="line">        count = 0</span>
<a id="line19"></a><span class="lineno">19</span><span class="line">        names = ir.sxr.keys()</span>
<a id="line20"></a><span class="lineno">20</span><span class="line">        <span class="py-keyword">if</span> names:</span>
<a id="line21"></a><span class="lineno">21</span><span class="line">            self.page_info.append([])</span>
<a id="line22"></a><span class="lineno">22</span><span class="line">        names.sort()</span>
<a id="line23"></a><span class="lineno">23</span><span class="line">        <span class="py-keyword">for</span> name <span class="py-keyword">in</span> names:</span>
<a id="line24"></a><span class="lineno">24</span><span class="line">            <span class="py-keyword">if</span> count &gt; 200:</span>
<a id="line25"></a><span class="lineno">25</span><span class="line">                count = 0</span>
<a id="line26"></a><span class="lineno">26</span><span class="line">                page += 1</span>
<a id="line27"></a><span class="lineno">27</span><span class="line">                self.page_info.append([])</span>
<a id="line28"></a><span class="lineno">28</span><span class="line">            self.page_info[page].append(name)</span>
<a id="line29"></a><span class="lineno">29</span><span class="line">            self.page_map[name] = page</span>
<a id="line30"></a><span class="lineno">30</span><span class="line">            entry = ir.sxr[name]</span>
<a id="line31"></a><span class="lineno">31</span><span class="line">            d, c, r = len(entry.definitions), len(entry.calls), len(entry.references)</span>
<a id="line32"></a><span class="lineno">32</span><span class="line">            count += 1 + d + c + r</span>
<a id="line33"></a><span class="lineno">33</span><span class="line">            <span class="py-keyword">if</span> d: count += 1</span>
<a id="line34"></a><span class="lineno">34</span><span class="line">            <span class="py-keyword">if</span> c: count += 1</span>
<a id="line35"></a><span class="lineno">35</span><span class="line">            <span class="py-keyword">if</span> r: count += 1</span>
<a id="line36"></a><span class="lineno">36</span>
<a id="line37"></a><span class="lineno">37</span><span class="line">    <span class="py-keyword">def</span> <a href="../../../../Scopes/Synopsis/Formatters/HTML/XRefPager/XRefPager.html#get">get</a>(self, name):</span>
<a id="line38"></a><span class="lineno">38</span><span class="line">        <span class="py-string">&quot;&quot;&quot;Returns the number of the page that the xref info for the given</span></span>
<a id="line39"></a><span class="lineno">39</span><span class="line"><span class="py-string">        name is on, or None if not found.&quot;&quot;&quot;</span></span>
<a id="line40"></a><span class="lineno">40</span>
<a id="line41"></a><span class="lineno">41</span><span class="line">        <span class="py-keyword">return</span> self.page_map.get(name)</span>
<a id="line42"></a><span class="lineno">42</span>
<a id="line43"></a><span class="lineno">43</span><span class="line">    <span class="py-keyword">def</span> <a href="../../../../Scopes/Synopsis/Formatters/HTML/XRefPager/XRefPager.html#pages">pages</a>(self):</span>
<a id="line44"></a><span class="lineno">44</span><span class="line">        <span class="py-string">&quot;&quot;&quot;Returns a list of pages, each consisting of a list of names on that</span></span>
<a id="line45"></a><span class="lineno">45</span><span class="line"><span class="py-string">        page. This method is intended to be used by whatever generates the</span></span>
<a id="line46"></a><span class="lineno">46</span><span class="line"><span class="py-string">        files...&quot;&quot;&quot;</span></span>
<a id="line47"></a><span class="lineno">47</span>
<a id="line48"></a><span class="lineno">48</span><span class="line">        <span class="py-keyword">return</span> self.page_info</span>
<a id="line49"></a><span class="lineno">49</span>
</pre>
<div class="logo">Generated on Thu Apr 16 16:27:14 2009 by 
<br/>
<a href="http://synopsis.fresco.org" target="_blank"><img src="../../../../synopsis.png" alt="logo"/> synopsis</a> (version devel)</div>
</body>
</html>
